import java.util.Random;

public class adfGenerator{
    private static Random random = GenerateGraphTreeWidth.getRandom();
    public static void main (String[] args) throws Exception{
	if (args.length!=5){
	    System.out.println("args not correct: java adfGenerator n, tw, ps, pc, pd\n"+
			       "                  n  ... number of nodes\n"+
			       "                  tw ... treewidth of the grid\n"+
			       "                  ps ... probability that an arb. edge is symmetric\n"+
			       "                  pc ... probability that a variable is substituted with a constant\n"+
			       "                  pd ... probability that a disjunction is used instaed of a conjunction\n");
	    System.exit(1);
	}
	System.out.println(adfGraph(GenerateGraphTreeWidth.generateGridG8(Integer.parseInt(args[0]),Integer.parseInt(args[1]),Double.parseDouble(args[2])),Double.parseDouble(args[3]),Double.parseDouble(args[4])));
    }

    /**
     * prints an adf-graph with the given probabilities (based on a 8-neighbourhood grid)
     * @param graph a 8 neighbourhood grid graph
     * @param pconst probability that a const is used instead of the variable
     * @param pdisjunct probability that the connective is a disjunction 
     * @return a grid based adf representation
     */
    private static String adfGraph(Graph<Integer> graph,double pconst, double pdisjunct){
	StringBuffer stringBuffer= new StringBuffer();
	int uniqueV=0;
	int uniqueF=0;
	
	for(Graph.Node<Integer> node : graph.getNodes()){
	    stringBuffer.append("arg("+node.getObject().toString()+").\n");
	    for(Graph.Node<Integer> child: node.getChildren()){
		stringBuffer.append("rel(");
		if (random.nextDouble()<=pconst){
		    if (random.nextDouble()<0.5)
			stringBuffer.append("v(" + Integer.toString(uniqueV++) + ")");
		    else
			stringBuffer.append("f(" + Integer.toString(uniqueF++) + ")");
		}else{
		    stringBuffer.append(node.getObject().toString());
		}
		stringBuffer.append(","+child.getObject().toString()+",");
		if (random.nextDouble()<0.5)
		    stringBuffer.append("p,");
		else
		    stringBuffer.append("n,");
		if (random.nextDouble()<=pdisjunct)
		    stringBuffer.append("d).\n");
		else
		    stringBuffer.append("c).\n");
	    }
	}
	
	return stringBuffer.toString();
    }
    
}